//+------------------------------------------------------------------+
//|                                                        RCFMA.mq4 |
//|                                         Copyright  2009, LeMan. |
//|                                                 b-market@mail.ru |
//+------------------------------------------------------------------+
//mod
#property  copyright "Copyright  2009, LeMan."
#property  link      "b-market@mail.ru"
//----  
#property  indicator_separate_window
#property  indicator_buffers 4
#property  indicator_color1  Blue
#property  indicator_color2  SaddleBrown
#property  indicator_width1  1
#property  indicator_width2  1


#property  indicator_color3  Green
#property  indicator_color4  DeepPink
#property  indicator_width1  1
#property  indicator_width2  1

//----  
extern int FastMA   = 4; //   
extern int MiddleMA = 9; //   
extern int SlowMA    = 17; //   
extern int SigMA    = 13; //

extern int FMAslopePer    = 1;
extern bool usevolume    = 0;
extern bool useosma    = 0;
extern bool use0crossEntry    = 1;

extern double slopemult   = 0.7;

extern int TypeFMA    = 1;
extern int TypeMMA    = 1;
extern int TypeSMA    = 1; // 0 - (SMA), 1 - (EMA), 2 - (SSMA), 3 - -(LWMA)
extern int PriceMMA = 0;
extern int PriceFMA = 0;
extern int PriceSMA = 0; // 0 - , 1 - , 2 - , 3 - , 4 - , 5 - , 6 -  
extern int PriceSigMA=0;
//----  
double     WASOMBuffer[];
double     DFMABuffer[];


double buffer1[];
double buffer2[];


//+------------------------------------------------------------------+
int init() {
//----
   IndicatorDigits(Digits+1);

   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexStyle(1, DRAW_LINE);
//----
   SetIndexBuffer(0,WASOMBuffer);
   SetIndexBuffer(1,DFMABuffer);
   
//----
   if (useosma) string name= "osmamode"; else name="macdmode"; 
   if (usevolume) string name1= " volumes"; else name1=""; 
   
   IndicatorShortName("RCFMA ("+FastMA+"; "+MiddleMA+","+SlowMA+","+SigMA+") "+name+name1);
   
   SetIndexLabel(0, "WASOM");
   SetIndexLabel(1, "DFMA");



   SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexStyle(3, DRAW_HISTOGRAM);

//   SetIndexStyle(0,DRAW_ARROW);   SetIndexArrow(0,159);   SetIndexEmptyValue(0,EMPTY_VALUE);
//   SetIndexStyle(1,DRAW_ARROW);   SetIndexArrow(1,159);   SetIndexEmptyValue(1,EMPTY_VALUE);
   
   SetIndexBuffer(2, buffer1);
   SetIndexBuffer(3, buffer2);



//----
   return(0);
}
//+------------------------------------------------------------------+
int start() {
   int limit;
   int counted_bars = IndicatorCounted();
//----
   if (counted_bars<0) return(-1);
   if (counted_bars > 0) counted_bars--;
   limit = Bars-counted_bars;
//----
   for (int i=limit; i>= 0; i--)
   {
     if (usevolume)  double vol=Volume[i];  else vol=1;

      if (useosma)
      WASOMBuffer[i]=iOsMA(NULL,0,MiddleMA,SlowMA,SigMA,PriceSigMA,i)*vol;
      else
      WASOMBuffer[i]=(iMA(NULL,0,MiddleMA,0,TypeMMA,PriceMMA,i)-iMA(NULL,0,SlowMA,0,TypeSMA,PriceSMA,i))*vol;
      

      DFMABuffer[i] =(iMA(NULL,0,FastMA,0,TypeFMA,PriceFMA,i)-iMA(NULL,0,FastMA,0,TypeFMA,PriceFMA,i+FMAslopePer))*vol*slopemult;
   
   
                           buffer1[i]=EMPTY_VALUE;   buffer2[i]=EMPTY_VALUE;


   int dfma= 0.0;
      if (use0crossEntry)
         {
         if (DFMABuffer[i+1]<0 && DFMABuffer[i]>0)dfma= 1;
         if (DFMABuffer[i+1]>0 && DFMABuffer[i]<0)dfma=-1;
         }
      else 
         {
         if (DFMABuffer[i]>0 && DFMABuffer[i]>DFMABuffer[i+1])dfma= 1;
         if (DFMABuffer[i]<0 && DFMABuffer[i]<DFMABuffer[i+1])dfma=-1;
         }      

      if(WASOMBuffer[i]>0 &&  WASOMBuffer[i]>WASOMBuffer[i+1] && dfma==  1)
         
         buffer1[i]=WASOMBuffer[i];




      if(WASOMBuffer[i]<0 && WASOMBuffer[i]<WASOMBuffer[i+1] && dfma== -1)
         
         buffer2[i]=WASOMBuffer[i];
   
   }
   
   //----
   return(0);
}
//+------------------------------------------------------------------+